﻿/* MOVIES GADGET VERSION 1	
original movies gadget by Manas Tungare (www.manastungare.com)
Thanks to Manas, Benjamin, Teo and the Google Desktop team
Designed by Kai
*/

//global variables////////////////////////////////////////////////////////////////////////////////////
var curr=new Object();
var detailsView=null;
////GENERAL Fucntions//////////////////////////////////////////////////////////////////////////////////////

function view_onOpen()
{
lastDetails="";
curr=new Object();
detailsView=null;
table=new Object();
movieNames= new Array();

imdbCounter=0;

for (i=0;i<3;i++){
	for (q=0;q<3;q++){
	mosaic[i][q].src="";
}}

size();
detailsView = new DetailsView();

  // Create the details view and set its content.
  detailsView.SetContent(
      "",             // Item's displayed website/news source.
      undefined,      // Time created
      "details.xml",  // The XML file
      false,          // Whether time is shown as absolute time
      0);             // Content layout flags
Update();

options.PutDefaultValue("mosaic","true");
if (options.GetValue("mosaic")=="false" && mosaicDiv.visible==true)
	switchView(1);
}

function switchView(param){
if (param!=1){
	bubble.visible=false;
	options.PutValue("bubble","false");
	beginAnimation("switchAnimation()",0,100,1000);
}
if (movieDiv.visible==false){
	movieDiv.visible=true;
	mosaicDiv.visible=false;
}else{
	movieDiv.visible=false;
	mosaicDiv.visible=true;
}

if (mosaicDiv.visible==true)
	options.PutValue("mosaic","true");	
else
	options.PutValue("mosaic","false");	
}

function switchAnimation(){
var value=event.value;
if (value>50)
	value=100-value;
top2.rotation=value;
}

//LISTBOX AND AND ITEMS STUFF/////////////////////////////////////////////////////////////////////////
var table=new Object();
var movieNames= new Array();
//table stores the items

//item
//item.name displayed name
//item.rating value from 1 to 5
//item.stars url for the stars. http://google.com needs to be added before
//item.url
//item.genre
//item.duration
//item.mpaaRating
//item.desc  duration +mpaaRating + genre
//item.showtimes in what theatres does it play
//item.reviews url of ratings
//item.imdb url of imdb
//item.trailer
//item.thumbUrl
//item.stream ->stream of the thumbnail
//item.youtube
//item.tagline
//item.description description text
//item.director
//item.cast[2]//top 3

var lastDetails="";

function listOnChange(listItem){
movieList.selectedIndex="-1";
if (table[listItem.children(0).innerText].thumbUrl)
	showDetailsByName(listItem.children(0).innerText);
}

function showDetailsByName(name){
if (name==lastDetails){
	plugin.CloseDetailsView(); 
	lastDetails="";
	return;
}
lastDetails=name;
if (!table[name].youtube)
	fetchYoutube(name);

var movie=table[name];
detailsView.detailsViewData.putValue("curr", movie);
detailsView.detailsViewData.putValue("showYoutube", showYoutube);
  
  // Show the details view  
  plugin.ShowDetailsView(detailsView,  // The DetailsView object
      movie.name,      // The title
      gddDetailsViewFlagNone,  // Flags
      onDetailsViewFeedback);  // The handler to call when details view closes

clearInterval(init);
}

function onDetailsViewFeedback(detailsViewFlags) {
  if (detailsViewFlags == gddDetailsViewFlagNone) {
    		if(options.GetValue("zoom")=="true")
			init=setInterval("runMosaic();",2000+2000*options.GetValue("speed"));
		else
			init=setInterval("runMosaic();",6000+2000*options.GetValue("speed"));
  }
}


function append(item){
	table[item.name]=item; 
	var starsX=movieDiv.width-69;
	movieList.appendElement("<listitem name=\"item\" tooltip=\""+item.name+"\"><label color=\"#FFFFFF\" tooltip=\""+item.name+"\">"+item.name+"</label><label color=\"#999999\" y=\"14\">"+item.desc +"</label></listitem>");
}

function removeAll() {
	movieList.removeAllElements();
}


// Hide and destroy the currently visible details view
function closeDetailsView() {
  plugin.CloseDetailsView();
}

//YOUTUBE////////////////////////////////////////////////////////////////////////////////////
var htmlDetailsView=null;
function showYoutube(name) {
var url=table[name].youtube;
var snippet = "<object id=\"movie\" width=\"100%\" height=\"100%\"><param name=\"movie\" "
        + "value=\"" +url + "&autoplay=1\"></param><embed "
        + "src=\"" + url + "&autoplay=1\" name=\"movie\" type=\"application/x-shockwave-flash\" width=\"100%\" "
        + "height=\"100%\" bgcolor=\"#000000\"></embed></object>";
  var detailsHTML = "<html><head><script>window.external.window = window;</script><style type=\"text/css\"> body{font-family:arial,sans-serif; font-size: 10px; margin-left: 3px; margin-top: 3px; margin-right: 3px; margin-bottom: 3px;}</style></head><body bgcolor=\"#000000\" text=\"#FFFFFF\" link=\#FFFF00\ vlink=\#FFCC99\ alink=\#FFFF00\ scroll=\"no\">";
  detailsHTML += snippet;
  detailsHTML += "<br /><br /></body></html>";

    plugin.closeDetailsView();
    clearInterval(init);

  htmlDetailsView = new DetailsView();
  htmlDetailsView.html_content = true;
 
 
  htmlDetailsView.setContent("", undefined, detailsHTML, false, 0);
  htmlDetailsView.external = {};

  // Show the details view
  plugin.showDetailsView(htmlDetailsView, name+" trailer", 
    gddDetailsViewFlagNone, onHtmlDetailsViewFeedback);
}

function onHtmlDetailsViewFeedback(detailsViewFlags) {
if(options.GetValue("zoom")=="true")
			init=setInterval("runMosaic();",2000+2000*options.GetValue("speed"));
		else
			init=setInterval("runMosaic();",6000+2000*options.GetValue("speed"));

  // Remove the movie from DOM to make it stop playing
  var window = htmlDetailsView.external.window;
  var movie = window.document.getElementById("movie");
  if (movie != null)
    movie.parentNode.removeChild(movie);

  if (detailsViewFlags == gddDetailsViewFlagNone) {
    // User closed the details view
  } else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen) {
    // User clicked on the title of the details view
    var winShell = new ActiveXObject("Shell.Application"); 
    winShell.ShellExecute(linkArray[index]); 
    winShell = null;
  }

  htmlDetailsView=null;
  CollectGarbage();
}


function sb_onchange(){
movieList.height=movieNames.length*33;
sb.max=movieNames.length*33-165;
if (sb.max<0)
	sb.max=0;
movieList.y=-sb.value;
}

