﻿/* MOVIES GADGET VERSION 1	
original movies gadget by Manas Tungare (www.manastungare.com)
Thanks to Manas, Benjamin, Teo and the Google Desktop team
Designed by Kai
*/

// ---- Options Dialog ----
options.PutDefaultValue("zoom","true");
options.putDefaultValue("location","san francisco");
options.putDefaultValue("sortbyname","false");
options.putDefaultValue("speed","4");
options.putDefaultValue("bubble","true");

if (options.GetValue("bubble")=="true")
	bubble.visible=true;

plugin.onShowOptionsDlg = ShowOptionsDlg;

function ShowOptionsDlg(wnd) {
 
var zoom;
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Location/Zip Code (US/Canada Only)", 40, 20, 200, 25);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "location", options.GetValue("location"),
      40, 40, 200, 24);

  wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Display Change Delay\n(in seconds; mosaic mode)", 40, 70, 220, 45);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "speed", options.GetValue("speed"),
      40, 100, 200, 24);

  var zoom = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "zoom",
    "Enable zoom effect.", 40, 140, 250, 24);
  zoom.value = (options.GetValue("zoom")=="true") ? "1" : "0";

var sorting = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "sorting",
    "Sort by name (instead of by popularity)", 40, 160, 250, 24);
  sorting.value=(options.GetValue("sortbyname")=="true") ? "1" : "0";

  wnd.onClose = OptionsDlgClosed;
}

function OptionsDlgClosed(wnd, code) {
  if (code != gddIdOK) {
    return;
  }

options.PutValue("location",wnd.GetControl("location").value);

if (wnd.GetControl("speed").value>=1 && wnd.GetControl("speed").value<1000000)
	options.PutValue("speed",wnd.GetControl("speed").value);

if (wnd.GetControl("zoom").value==0)
	options.PutValue("zoom","false");
else
	options.PutValue("zoom","true");


if (wnd.GetControl("sorting").value==0)
	options.PutValue("sortbyname","false");
else
	options.PutValue("sortbyname","true");

view_onOpen();
}


plugin.onAddCustomMenuItems = AddCustomMenuItems;
function AddCustomMenuItems(menu) {
menu.AddItem("Help and more Info", 0,onlineHelp );
menu.AddItem("Switch Views",0,switchView);
menu.AddItem("Refresh",0,view_onOpen);
}

function onlineHelp(){
showPage("http://www.yannickstucki.com/movies.html");
}