﻿/* MOVIES GADGET VERSION 1	
original movies gadget by Manas Tungare (www.manastungare.com)
Thanks to Manas, Benjamin, Teo and the Google Desktop team
Designed by Kai
*/

//Parsing from Manas Tungare
//Thanks Manas --------- www.manastungare.com

var kMoviesUri = "http://www.google.com/movies?output=xhtml&near={loc}&sort={sort}&start={start}";
//test url=http://www.google.com/movies?output=xhtml&near=san francisco&sort=3
var kMpaaRatings = new Array("G", "PG", "PG-13", "R", "NC-17", "Unrated");
var knownMpaaRatings = "," + kMpaaRatings.toString() + ",";
var kWapDtdHeader =
  '<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN"' +
  ' "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">';
var kGenres = new Array("Action", "Animation", "Adventure", "Comedy", "Documentary",
    "Drama", "Family", "Musical", "SciFi", "Suspense", "Thriller");

var kDefaultUserRating = 5.0; // used if user rating not available.
var kDefaultMinimumUserRating = 0.0; // show all movies above this rating.
var kMaximumUserRating = 5.0; // no rating above this.
var kUserRatingStepSize = 0.5;
var http;
var start=0;
var finished; //because it has more than 1 page

var imdbCounter=0;

function Update(){
removeAll();
if (options.GetValue("sortbyname")=="true")
	movieList.visible=false;
else
	movieList.visible=true;

start=0;
finished=false;
sendListingRequest()
}
options.putDefaultValue("sort","1");
function sendListingRequest() {
  var reqUri = kMoviesUri.replace(/\{loc\}/g, encodeUrl(options.GetValue("location" )));
  reqUri = reqUri.replace(/\{sort\}/g, options.GetValue("sort"));
  reqUri = reqUri.replace(/\{start\}/g, start);

  http = new XMLHttpRequest();
  http.onreadystatechange = OnReceivedData;
  // http.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
  http.open("GET", reqUri + "&noCache=" + Math.random(), true);
  try {
    http.send();
  }
  catch(e) {
    //
  }

}

function OnReceivedData() {
if (http && http.readyState == 4) { // completed?
try{
    // MSXML doesn't like entities such as "&nbsp;" and "&copy;", so we trim
    // them off first. We also trim the DOCTYPE decl because MSXML tries to
    // fetch and validate against it. This is bad because
    // (1) it causes an HTTP request, and (2) it doesn't validate! ;)

    var cleanXml = replaceXmlEntities(http.responseText);
    cleanXml = cleanXml.replace(kWapDtdHeader, '');

    var doc = new DOMDocument();
    if(!doc.loadXML(cleanXml)) {
      // utils.alert(getErrorMessage(doc.parseError));
      return;
    }

    var anchors = doc.getElementsByTagName("a");

    if (anchors == null || anchors.length == 0) {
      utils.alert(invalidZipCode);
    } else {
      // Last three links are "Google Home", "Continue" and "next"; skip them.
      // Add in reverse order, so they appear right-side-up in the sidebar.

      var numMovies = anchors.length - 3;
	
//the 3rd one is maybe next (or a movie or prev) check this now //the 3rd element is already removed
//it's either the 1st page: with next: continue, remove next | or without next: stop and don't remove anything
//it can be a page in the middle: remove next and ref, continue
//it can be the end page: remove prev and stop: finished= true

	if (anchors[numMovies].firstChild.nodeValue.indexOf("Next »")!=0){//either 1st page without next or end
	finished=true;//then it's over anyways
		if (start==0){//so 1st page and only 1 page
		numMovies++;//cause else a movie would be cut out
		}
	}
	else if (anchors[numMovies-1].firstChild.nodeValue.indexOf("« Prev")==0){//check if there is a prev to take out
	numMovies--; //cause we need to take out one more
	}
		

      for (var i = 0; i <= numMovies - 1; ++i) {
        try {
          // Parsing may fail at any point, any line.     
   var anchor = anchors[i];

        var title = anchor.firstChild.nodeValue;
        var uri = anchor.attributes[0].value;
	var desc = anchor.nextSibling.nextSibling.nodeValue;

        if (desc == null) {
          desc = "";
        }

          var descParsed = desc.split(" - ");
          var duration = descParsed[0];
	  var length=4;
          // parse the description
	if (knownMpaaRatings.indexOf(","+descParsed[1]+",")!=-1){   //it has a rating
		mpaaRating=descParsed[1];
		genre=descParsed[2];
		}
	else	{
		mpaaRating="Unrated";
		genre=descParsed[1];
		length--;
		}

	var rating;
	var stars;
	if (descParsed.length==length){
		rating = anchor.nextSibling.nextSibling.nextSibling.attributes[1].value;
		rating=rating.substring(6,9);
		stars=anchor.nextSibling.nextSibling.nextSibling.attributes[0].value;
		stars=stars.replace("/xhtml/images/","stars\\");
	}
	else{
		rating=stars="";
	}
        }
        catch(e) {
          // Parsing failed. Shrug once and move on ...
        }

        // If rating is a valid number, then check if rating is high enough.
      /*  if (parseFloat(userRating)!= "NaN" && userRating < options.GetValue("MinimumUserRating")) {
          continue;
        }
*/
     /*   // Skip if user has turned off movies of this MPAA rating; DO NOT SKIP if we don't
        // know about this rating at all. (USA != World)
        var knownMpaaRatings = "," + kMpaaRatings.toString() + ",";
        if (-1 == options.GetValue("MpaaRatings").indexOf("," + mpaaRating + ",") &&
            -1 != knownMpaaRatings.indexOf("," + mpaaRating + ",") ) {
          continue;
        }

        // Skip if this genre has been turned off; DO NOT SKIP if we don't
        // have an option for this genre (= unknown genre).
        var knownGenres = "," + kGenres.toString() + ",";
        if (-1 == options.GetValue("Genres").indexOf("," + genre + ",") &&
            -1 != knownGenres.indexOf("," + genre + ",") ) {
          continue;
        }
*/
        var movieItem = new MovieListingItem(title,uri,stars,desc,finished);
        movieItem = null; // to release the reference we have
      }
    }

    http = null;  // free the http object
if (finished==false)
{
start+=15;
sendListingRequest()
}
}
catch (e){
alert("Can't load movies. Maybe you entered an invalid location. Please go to the options and change it.");
}
}
}

function MovieListingItem(title,reqUri,stars,desc,finished) {
movieNames[movieNames.length]=title;
var item=new Object();
item.name=title;
item.url=reqUri.replace("output=xhtml", ""); // Take user to non-XHTML page.    
item.stars=stars;    
item.desc=desc;

var imdbHttp=new XMLHttpRequest();
imdbHttp.onreadystatechange = function(){
OnImdbReceivedData(item.name, imdbHttp,finished);
};
imdbHttp.open("GET", item.url,true);imdbHttp.send();  
item.imdb="";
item.stream="";
append(item);
}

function OnImdbReceivedData(name,imdbHttp,finished){
if (imdbHttp.readyState==4){
	var page=imdbHttp.responseText.substring(0,imdbHttp.responseText.indexOf("IMDb"));
	page=page.substring(page.lastIndexOf("http://www.imdb"),page.length);
	page=page.substring(0,page.indexOf("&")-1);
	page=page.replace("www","us");
	table[name].imdb=page;
imdbCounter++;
if (finished==true && imdbCounter==movieNames.length)
	initialize();
}
}